<?php
///////////////////////////////////////////////////////////////////////////////
//
// PHP IRC-layer sample application
//
// This script goes online and checks wether the given nick is online or not.
//
// Usage: http://my.server.net/isonline.php3?nick=coolnick
//
// This software and all associated files are released
// under the GNU Public License (GPL), see gpl.txt for details.
//
// Copyright (c) 1999, 2000 by Till Gerken, till@phpwebdev.com
//
///////////////////////////////////////////////////////////////////////////////

// Include the IRC layer
include("../phpIRC.inc.php3");
include("../phpIRC.php3");

///////////////////////////////////////////////////////////////////////////////
//
// Main code
//

$wanted_server = "irc.server.org";  		// server we want to connect to
$wanted_port = 6667;				// port on server to connect to

$wanted_nick = uniqid("a");			// generate random nickname
$wanted_nick = substr($wanted_nick, 0, 8);

// initialize IRC layer
if(!irc_init())
	die("Initialization error.<br>");

// uncomment this if you want debug output
//irc_set_debug_mode(1);

// set our nick
irc_change_nick($wanted_nick);

// try to connect to server
if(!irc_connect($wanted_server, $wanted_port))
	die("Connection error.<br>");

// do a whois on the wanted nick
if(!irc_whois($nick))
	print("$nick is not online.<br>");
else
	print("$nick is online!<br>");

irc_disconnect("");

?>
