<?php
///////////////////////////////////////////////////////////////////////////////
//
// PHP IRC-layer sample application
//
// This is a small bot, pretty much doing nothing but going online and
// sitting there, echoing all messages to the screen, until a quit request
// is received.
//
// It requires a MySQL table containing just one character field containing
// a userhost. You can put as many userhosts as you wish into the table.
// Whenever someone with a userhost matching the list in the database joins
// the same channel the bot is in, it will automatically op him/her.
//
// To make the bot quit, someone with a recognized userhost must message him
// "shuddup" in private.
//
// This software and all associated files are released
// under the GNU Public License (GPL), see gpl.txt for details.
//
// Copyright (c) 1999, 2000 by Till Gerken, till@phpwebdev.com
//
///////////////////////////////////////////////////////////////////////////////

// Include the IRC layer
include("../phpIRC.inc.php3");
include("../phpIRC.php3");

$wanted_nick = "lilbot";			// the nick we prefer
$wanted_server = "my.ircserver.net";		// server we want to connect to
$wanted_port = 6667;				// port on server to connect to
$wanted_channel = "#mychannel";			// channel we want to join

$db_host = "db.server.com";
$db_user = "sqluser";
$db_pass = "sqlpass";
$db_name = "mydb";
$table_name = "phpBot_users";

$mysql_handle = 0;

///////////////////////////////////////////////////////////////////////////////
//
// privmsg_callback()
//

function privmsg_callback($code, $nick, $identd, $host, $destination, $text)
{
	global $wanted_nick, $db_name, $table_name;
	
	if(($destination == $wanted_nick) && ($text == "shuddup"))
	{
		$mysql_result = mysql_db_query($db_name, "SELECT * FROM $table_name");
		if(!$mysql_result)
			return;
	
		$done = 0;
		while(($user_object = mysql_fetch_object($mysql_result)) && !$done)
		{
			$userhost = $user_object->userhost;
			$neededhost = $nick."!".$identd."@".$host;
		
			$userhost = str_replace("*", "(.*)", $userhost);
		
			if(ereg($userhost, $neededhost))
			{
				irc_disconnect("Quit request received");
				$done = 1;
			}
		}
	}

}

///////////////////////////////////////////////////////////////////////////////
//
/// onjoin_callback()
//

function onjoin_callback($code, $nick, $identd, $host, $destination, $text)
{
	global $wanted_channel, $mysql_handle, $db_name, $table_name;

	$mysql_result = mysql_db_query($db_name, "SELECT * FROM $table_name");
	if(!$mysql_result)
		return;
	
	$done = 0;
	while(($user_object = mysql_fetch_object($mysql_result)) && !$done)
	{
		$userhost = $user_object->userhost;
		$neededhost = $nick."!".$identd."@".$host;
		
		$userhost = str_replace("*", "(.*)", $userhost);
		
		if(ereg($userhost, $neededhost))
		{
			irc_put_message("MODE $wanted_channel +o $nick");
			$done = 1;
		}
	}

}

///////////////////////////////////////////////////////////////////////////////
//
// Main code
//

ignore_user_abort(1);
set_time_limit(0);
error_reporting(63);

$mysql_handle = mysql_connect($db_host, $db_user, $db_pass);
if(!$mysql_handle)
	die("MySQL error.<br>");

// initialize IRC layer
if(!irc_init())
	die("Initialization error.<br>");

// turn on debugging
irc_set_debug_mode(1);

// set our nick
irc_change_nick($wanted_nick);

// try to connect to server
if(!irc_connect($wanted_server, $wanted_port))
	die("Connection error.<br>");

// join a channel
$channel_handle = irc_join($wanted_channel);

// in case the join failed -> quit
// the join will NOT fail in case the channel is invite-only or
// a similar reason exists preventing us from getting in!
if(!$channel_handle)
	die("Join error.<br>");

irc_set_mode($wanted_channel, "+nt", "");

irc_add_callback(IRCCB_ONPRIVMSG, "privmsg_callback");
irc_add_callback(IRCCB_ONJOIN, "onjoin_callback");

// ok, this is the main loop - we don't give a break condition
// here, so this will not return until we get disconnected.
// the only possibility to gain control again is via callbacks.
irc_idle(IRC_NOBREAK);

mysql_close($mysql_handle);

?>
