#!/usr/bin/perl
#######################################################
#		Redirect It version 1.0
#
#     	Created by: Solution Scripts 
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# This program is being distributed as freeware.  It may be used and
# modified free of charge, so long as this copyright notice, the header 
# above and all the footers in the program that give me credit remain 
# intact. Please also send me an email, and let me know 
# where you are using this script. 
#
# By using this program you agree to indemnify Solution Scripts from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Warranty Disclaimer
# --------------------
# THIS SOFTWARE AND THE ACCOMPANYING FILES ARE AVAILABLE "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OR MERCHANTABILITY OR ANY
# OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED.
#
# The user assumes the entire risk of using the program.  
#
######################################################

require "variables.pl";

use Fcntl;
use AnyDBM_File;
use Config;

$flags = O_RDONLY;
$db = "$Config::path/usersdb";

$uri = $ENV{'REQUEST_URI'};
$uri =~ s/\///;

if ($Config::type eq "subdomain") {
	$username = $ENV{'HTTP_HOST'};
	$username =~ s/^www\.//i;
	$username =~ s/\.$Config::domain//i;

}
else {
	@urs = split(/\//,$uri);
	$username = $urs[0];
	$uri =~ s/$username//i;
	$uri =~ s/\///;
}

unless ($username) {
	print "Location: $Config::default\n\n";
	exit;
}

tie(%acc, 'AnyDBM_File', $db , $flags, 0666) || &error("Cannot Read -- $db");
unless ($acc{$username}) {
	print "Location: $Config::default\n\n";
	untie(%acc);
	exit;
}	

print "Content-type: text/html\n\n"; 

$user_array = $acc{$username};
untie(%acc);

@userdata = split(/\|\|\|/,$user_array);

if ($uri) {
	$userdata[0] = "$userdata[0]/$uri";
}

# PLEASE respect us and our software and do not remove or change
# the Solution Scripts link. Thank You.....


$meta = qq~
<HTML><head>
<title>$Config::name</TITLE>
<META HTTP-EQUIV="REFRESH" CONTENT="$Config::meta_time; URL=$userdata[0]";>
</HEAD>
$Config::meta_body
<TABLE bgcolor=white border=1 cellspacing=0 cellpadding=3 align=center>
<TR><TD align=center>
<FONT FACE=arial size=-1>You are now being redirected to:
<BR>
<B><A HREF="$userdata[0]">$userdata[2]</A></B></FONT>
</TD></TR></TABLE>

$Config::meta_text
<BR><BR>
<TABLE bgcolor=white border=1 cellspacing=0 cellpadding=3 align=center>
<TR><TD align=center>
<FONT FACE=arial size=-1>Redirection software provided by:
<BR><a href="http://solutionscripts.com">Solution Scripts</a>
</TD></TR></TABLE>
<BR><BR>
</BODY></HTML>
~;


$frames = qq~
<HTML><head>
<title>$Config::name</TITLE>
<script language="JavaScript">
<!-- begin script

redirect = window.open("$Config::ad_url", "solutions", "toolbar=no,location=no,directories=no,menubar=no,scrollbars=no,resizable=no,width=$Config::ad_width,height=$Config::ad_height");

function redirectFrame () {
  return '<html><body bgcolor="#FFFFFF" text="#000000"><CENTER>' +
    '<FONT FACE=arial size=-1><B>Redirection by <A HREF="http://$Config::domain" target="_TOP">$Config::name</A></B></FONT> ' +
    '<FONT FACE=arial size=-2>Software provided by: <a href="http://solutionscripts.com" Target="_TOP">Solution Scripts</a>'+
    '</FONT>'+
    '</body></html>'
}

// end script -->
</script>
<frameset rows='*,25'>;
<frame name='main' FRAMEBORDER="0" FRAMESPACING="0" MARGINWIDTH="0" MARGINHEIGHT="0" SCROLLING="auto" RESIZE=NO src='$userdata[0]'>;
<frame name='redirect' FRAMEBORDER="0" FRAMESPACING="0" MARGINWIDTH="3" MARGINHEIGHT="3" SCROLLING="auto" RESIZE=NO src='javascript:parent.redirectFrame()'>;
</frameset>
~;

if ($Config::redirect_type eq "meta") {
	print $meta;
}
else {
	print $frames;
}


exit;