#!/usr/local/bin/perl

# NOTE:  the above line must be changed to show the path to the
# Perl interpreter on your system!  Leave the #! as is, but
# the path may have to be changed if yours is different.

#########################################################################
# SillySearch v2.0 Oct 30, 1998						#
#									#
# A simple program that allows you to let people search through files in#
# a given directory on your web server for pages containing a word or	#
# words. You can let them search for pages containing all the words 	#
# entered, or just any one of the words entered.  The program will then	#
# grab the pages' titles from the HTML "title" tags in the page, and 	#
# display a page with links to those pages.				#
#									#
# Bug fixes 07/04/99: Fixed a bug that made the last search result show #
# up twice. Changed a bit about the way the . and .. files were removed.#
# Made the program search .txt files as well as .htm and .html files.   #
#									#
# New in v2.0 07/05/99: You can now have the program search multiple    #
# directories on your site instead of just one. See the README file for #
# details.								#
#									#
# Copyright 1998, Kristina L. Pfaff-Harris, scripts@tesol.net    	#
# All rights reserved.                                             	#
#########################################################################
##### Licensing:							#
#####									#
#####  This program may be used free of charge under the following	#
#####  conditions:							#
#####  									#
#####  1. All instructions and Copyright lines must remain unchanged.	#
#####  2. All pages generated by the program must contain one of the	#
#####     following pieces of HTML code:				#
#####  									#
#####     <font size=-2>SillySearch Copyright 1998-1999 Kristina	#
#####     Pfaff-Harris and can be found at: 				#
#####     <a href="http://www.tesol.net/scripts/">			#
#####     http://www.tesol.net/scripts</a></font>			#
#####  OR:								#
#####     <!-- SillySearch Copyright 1998 Kristina Pfaff-Harris -->	#
#####     <!-- Get it at http://www.tesol.net/scripts/         -->	#
##### 									#
#####  3. You may not sell or distribute this program.  You may charge	#
#####     a reasonable fee for installing it for a client as long as	#
#####     you make it clear that you are not the author, and you are	#
#####     not selling the program to them: only charging for installing	#
#####     it. 								#
#####  4. You agree that this program is offered without warranty of	#
#####     any kind, including warranty of fitness for a particular	#
#####     purpose. You further agree that the author and all sites 	#
#####     associated in any way with this program are not liable for	#
#####     any damage or loss incurred as a result of using this program.#
#########################################################################
#####									#
##### IMPORTANT INSTRUCTIONS:						#
#####									#
##### In this program, I have put **CHANGE** in all the places where	#
##### you will need to modify the program to run on your server, so	#
##### that you can easily find all the places where changes are 	#
##### necessary.  This program must be chmod 755 or 775 in order to	#
##### work. 								#
#####									#
##### Your web server must have permission to read and list files on	#
##### your website, and permission to run cgi programs. Ask the 	#
##### technical support people for your website if you're not sure 	#
##### if you have permission to run cgi scripts on your site.		#
#####									#
##### Where this file goes depends on how your web server is set up.	#
##### Sometimes, all cgi files MUST be in the "official" cgi-bin	#
##### directory.  Other times, the files can be anywhere as long as	#
##### they end in ".cgi".  Again, check with your system administrator	#
##### to see where you need to put this.				#
#####									#
#########################################################################
#									#
# I hope this program proves useful to you!  Please contact me  	#
# (scripts@tesol.net) for any bugs or feedback.				#
#									#
#########################################################################
# Leave the next three lines as they are unless you know what your
# PATH is. :)
$ENV{"PATH"} .= ":/usr/local/bin:/usr/local/lib/perl:/usr/bin";
%data= &get_data();
print "Content-type: text/html\n\n";

#### IMPORTANT!  If you are having trouble setting this up, or
#### finding where your files are supposed to be, you can use
#### the following to get some information about what the script
#### is trying to do, and where it's trying to look for files.
#### If you're having trouble, **CHANGE** $debugging = 0; to
#### $debugging = 1; and try running the script again.

$debugging = 0;

# Base Directory is the main system path to the files to search.
# This is NOT a URL, and should not begin with "http://". On
# Unix systems, you can usually telnet in to your server, cd to
# the directory where your web files are, and type "pwd" to get
# the path.  On windows NT, you sort of have to know what the
# directory is.  Sometimes on NT, you can put the path in in
# Unix (forward slash) format like below. If that doesn't work,
# try "C:\\YourDirectory\\YourOtherDirectory" or sometimes
# "C:/YourDirectory/YourOtherDirectory" depending on what version
# of Perl and NT you have.
# **CHANGE** this to the base path to where your web
# pages are located.  Don't put a trailing / or \\ on the end
# of this.

$basedir = "/home/staff/kristina/WWW";

# Base URL is the main URL for your website.  This must begin
# with "http://". **CHANGE** this to your own URL. Don't put
# a trailing / on the end of it, though.:

$baseurl = "http://www.linguistic-funland.com";

# $htmlheader is the HTML you want to appear at the top of 
# pages generated by the program. It can contain any text,
# but any of the following characters must have backslashes (\)
# in front of them: ", @, $, %. E.g. \", \@, \$, \%
# You may **CHANGE** any of the HTML code in between the lines
# that say <!-- Begin HTML header --> and
# <!-- End HTML header -->.

$htmlheader = "
<!-- Begin HTML header -->
<html><head><title>SillySearch v2.0</title></head>
<body bgcolor=#FFFFFF>
<center><h1>SillySearch v2.0</h1></center><P>

<!-- End HTML header -->

"; #<-- This " and ; are necessary. Do NOT backslash them! :)

# $htmlfooter is the HTML code you want to appear at the bottom of
# pages generated by the program.  Follow the same rules as for
# $htmlheader above.

$htmlfooter = "
<!-- Begin HTML footer -->

<hr>
<font size=-2>SillySearch v2.0 Copyright &copy; 1998 Kristina Pfaff-Harris.
Get it at <a href=http://www.linguistic-funland.com/scripts/>
http://www.linguistic-funland.com/scripts/</a></font>
<hr>
</body>
</html>

<!-- End HTML footer -->

"; #<-- This " and ; are necessary. Do NOT backslash them! :)

#########################################################################
#									#
# You should NOT need to change anything beyond this point, but you	#
# can read through the script if you're interested in what it's doing.  #
#									#
#########################################################################
&debug("Your operating system appears to be $^O.");
&debug("Your web server appears to be $ENV{'SERVER_SOFTWARE'}");

# Now, we just print out a message confirming what the user was
# searching for...
print "$htmlheader <strong>Searching for \"$data{'searchterm'}\"</strong>
	<br>Percentage numbers indicate what percent of the search words were
	found in the file, and do not necessarily indicate how close
	together they were.<hr>";

# This is a hack to let people search more than one directory. :)

if($data{'directory'} =~ /,/){

  @dirstosearch = split(/,/, $data{'directory'});
  foreach $thingie (@dirstosearch){
    $thingie =~ s/\%BASEDIR\%//;
    &main_program($thingie);
    }
}
else {
  $data{'directory'} =~ s/\%BASEDIR\%//;
  &main_program($data{'directory'});
  }

# Now, this is a cleanup.  If we went through all the files and didn't
# find anything, then $num will still be 0. So, let's tell the people
# that we didn't find anything.

if ($num <= 0){

  print "Nothing was found to match $data{'searchterm'}.
	 $htmlfooter";
	 exit();
  }

# Now, we'll split up the results into an array,
@results = split(/\|/, $results);

# Sort that array in reverse order so that 100% matches come first,
@results = reverse sort(@results);

foreach $result (@results){

# Now, since we needed a leading 0 on the % scores for sorting 
# purposes, but since 080% looks weird, we'll hack off the leading
# 0(s) with a pattern match:

   $result =~ s/^0+//;
   print "<p>$result\n";
   $result = "";
   }

# Now we'll print out our html footer, and exit.

print "$htmlfooter";
exit();

sub main_program {

$dirtosearch = $_[0];

# $file_location is the basedir plus the directory from the
# field on the form. This is how you tell the program where to search
# for files.

$file_location = "$basedir/$dirtosearch";
$file_location =~ s/\/$//;
&debug("Searching '$file_location' for files...");

# Just to make it prettier, we'll just create a variable that will say
# all the search terms with AND or OR in between them depending on
# the search type.

$what_we_are_searching_for = $data{'searchterm'};
$andor = $data{'andor'}; $andor =~ tr/[a-z]/[A-Z]/;
$what_we_are_searching_for =~ s/\s+/ $andor /g;

# If they didn't enter any words to search for, print them a message
# telling them so, and exit.

if($data{'searchterm'} eq ""){
  print "Nothing to search for. $htmlfooter";
  exit();
 }

# Now, open the directory that contains the files we're looking for,
opendir(DIR, "$file_location") || 
   &debug("Can't open directory $file_location: $!");

# Put the list of all files in that directory into the array @files...
@files = readdir(DIR);

# And close the directory just to be tidy.
closedir(DIR);

# Let's just pop off the . and .. files first:

foreach (@files){
  if($_ ne "." && $_ ne ".."){
     $t_files[$i] = $_;
     $i++;
     }
  }

@files = @t_files;

# Just a quick check to make sure there are any files...

if($#files == 0){
   &debug("Whoops, no files found to search through (around line 182).");
   }

# Now, for each one of the filenames in our array @files, we will
# perform the following steps to search for the file(s) containing
# the word or words the person entered.

foreach $file (@files){

# Let's clear out some variables before we start. Yes, I could have
# just scoped them better: what do you expect from something called
# SillySearch? :)

$found_items = "";
$orsearch = "";

# We are only searching files that end in .htm, or .html or .txt.

  if($file =~ /\.html$/i || $file =~ /\.htm$/i || $file =~ /\.txt$/i){

# If the file indeed is one we want to look through, then open it up, 
    open(FILE, "$file_location/$file") 
    || &debug("Can't open $file_location/$file for reading: $!");

# From the beginning to the end of the file, look through each line,

      while(<FILE>){


# If the user wants only results with ALL the terms, ("and"), use the
# subroutine "andsearch" on the special variable $_ (the current line
# in the file).

       if($data{'andor'} eq "and"){
	  &andsearch($_);
          }

# Otherwise, use the subroutine "orsearch" instead.
       if($data{'andor'} eq "or"){
          &orsearch($_);
          }
       }
  $score = 0;
  $goodscore = $#terms + 1;
  foreach $term (@terms){
    if($found_items =~ /$term/i){
       $score++;
       }
    }
  if ($data{'andor'} eq "and" && $score == $goodscore){
      $foundit = 1;
      }
  elsif($data{'andor'} eq "or" && $orsearch eq "successful"){
      $foundit = 1;
      }
  else{ $foundit = 0;}

# Both &andsearch() and &orsearch() produce a variable called "$foundit".
# If the search is successful, then $foundit = 1. If not, then it equals
# 0. So, if $foundit equals 1, we found a result,
	if($foundit == 1){

# Now open the file we were searching through to get its title from
# between the <TITLE> html tags with the "grep()" function,

	   open(FILE2, "$file_location/$file") ||
	     &debug("Can't open $file_location/$file for reading: $!");
	     @wholefile = grep(/<TITLE>/i, <FILE2>);
	   close(FILE2); 
	   $wholefile = join(/\n/, @wholefile);
	   $wholefile =~ /(.*)(<title>)(.*)(<\/title>)/i;
	   $wholefile = $3;

# Ah, but what if there are no <TITLE> tags?  Well, then, we'll just give
# them the filename instead:

	   if($wholefile eq ""){
		$wholefile = "$file";
		}

# Now, we'll divide the score they got by the score they were supposed
# to have, multiply that by 100 (to get percent), and take the integer
# value + .5 to round it up.

$printscore = int((($score/$goodscore) * 100) + .5);

# If it's less than 100, tack a 0 on the front so it will sort 
# results correctly...

if($printscore < 100){
   $printscore = "0$printscore";
   }
# And, we'll add the results into a variable, so we can sort them
# later, and make $num > 0 so we know we found something.

  	   $num++;
	   if($dirtosearch ne "" && $dirtosearch !~ /\/$/){
	      $dirtosearch = "$dirtosearch/";
	      }
           $results .= "$printscore%: <a href=\"$baseurl/$dirtosearch$file\">$wholefile</a><br>|" if $lastfile ne $file;
	   $lastfile = $file;
           close(FILE);

# And skip to searching the next file, since if we found a result, there's
# no sense continuing to search and wasting processor and memory. :)
	   next;
          }
       
    }
 }

}
#################################################################
#								#
# Now here are the subroutines...				#
#								#
#################################################################

# Gets the data from the html form into a form we can use in the
# program.
sub get_data {

# Declare a local variable called $string...
    local($string);

    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $string = $ENV{'QUERY_STRING'};
    }				
    else { read(STDIN, $string, $ENV{'CONTENT_LENGTH'}); }

    # split data into name=value pairs
    @data = split(/&/, $string);
   
    # split into name=value pairs in associative array
    foreach (@data) {
	split(/=/, $_);
	$_[0] =~ s/\+/ /g; # plus to space
        $_[0] =~ s/%0D%0A%0D%0A/\n\n/g; 
        $_[0] =~ s/%0a/newline/g;
	$_[0] =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
	$data{"$_[0]"} = $_[1];
    }

    # translate special characters
    foreach (keys %data) {
	$data{"$_"} =~ s/\+/ /g; # plus to space
	$data{"$_"} =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
    }

    %data;			# return associative array of name=value
}

# Use this if someone wants all the words to appear in the file...

sub andsearch {

# first, get all the terms into an array,

@terms = split(/\s+/, $data{'searchterm'});

# For each word that we get by splitting up the user's entry 
# into separate words wherever there's a space,

foreach $term (@terms){

# If the line from the file that we passed to this subroutine
# has the term in it,

   if($_[0] =~ /$term/i){

# Then we found one, so let's keep track of what we found...
    $found_items .= "$term " unless $found_items =~ /$term/;
# And look for the next term in the same line...
    next;
    } 

  }
# If we found them all, it's cool and we can stop...

#  print "Terms $found_items<br>";
}

# Use this to find  pages with any of the terms entered...
sub orsearch {

#local(@terms,$term,$orsearch,$found_items);

@terms = split(/\s+/, $data{'searchterm'});
# Pretty similar to andsearch.  for each word they entered,
  foreach $term (@terms){

# if the word appears in the file,
  if($_[0] =~ /$term/i){
    $orsearch = "successful";

# Then we found one, so let's keep track of what we found...
    $found_items .= "$term " unless $found_items =~ /$term/;
# And look for the next term in the same line...
    next;
   }
  }
}

sub debug {

 if($debugging == 1){
    print "$_[0]<br>";
    }
}
