<?

// functions

function get_unique_id() {
	$id = microtime();
	$id = str_replace(" ", "_", $id);
	$id = str_replace(".", "_", $id);
	return $id;
}

function get_friendly_timestamp($timestamp) {
	$year = substr($timestamp, 0, 4);
	$month = substr($timestamp, 4, 2);
	$day = substr($timestamp, 6, 2);
	$hour = substr($timestamp, 8, 2);
	$min = substr($timestamp, 10, 2);
	$sec = substr($timestamp, 12, 2);
	
	$temp = $month."/".$day."/".$year." ".$hour.":".$min.":".$sec;
	return $temp;
}

function print_friendly_timestamp($timestamp) {
	print(get_friendly_timestamp($timestamp));
}

function get_HTML($temp) {
	$temp = str_replace('&', '&amp;', $temp);
	$temp = str_replace('"', '&quot;', $temp);
	$temp = str_replace('<', '&lt;', $temp);
	$temp = str_replace('>', '&gt;', $temp);
	return $temp;
}	

function print_HTML($temp) {
	print(get_HTML($temp));
}	

function delete_task($task, $delete_type = "") {
	switch ($delete_type) {
		case "recursive":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				delete_task($child, "recursive");
			}
			break;
		case "orphan":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				$child->parent = "";
				$child->add_slashes();
				$child->update();
			}
			break;
		case "remove_generation":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				$child->parent = $task->parent;
				$child->add_slashes();
				$child->update();
			}
			break;
	}
	$task->obsolete();
	set_parent_task_status($task->id);
}

function complete_task($task, $complete_type = "", $reason = "") {
	switch ($complete_type) {
		case "recursive":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				complete_task($child, $complete_type, $reason);
			}
			break;
		case "orphan":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				$child->parent = "";
				$child->add_slashes();
				$child->update();
			}
			break;
		case "remove_generation":
			foreach ($task->children as $child_id) {
				$child = new task;
				$child = $child->retrieve($child_id);
				$child->parent = $task->parent;
				$child->add_slashes();
				$child->update();
			}
			break;
	}
	$task->status = 100;
	if (!empty($reason)) {
		$reason = get_HTML(stripslashes($reason));
		$task->notes = "-----  ".date("m-d-Y")." @ ".date("H:i")."  ---------------------\n\n"."Closed with reason: ".$reason."\n\n----------------------------------------------------\n\n".$task->notes;
	}
	$task->add_slashes();
	$task->update();
	set_parent_task_status($task->id);
}

function set_parent_task_status($task_id) {
	global $database;
	$task = new task;
	$task = $task->retrieve($task_id);
	if (!empty($task->parent)) {
		$task->lineage = $task->find_lineage();
		foreach ($task->lineage as $parent_id) {
			$parent = new task;
			$parent = $parent->retrieve($parent_id);
			if (count($parent->children) > 0) {
				$result = mysql_query("SELECT status FROM $database->table_name WHERE parent = '$parent_id' AND obsolete != '1'");
				$child_status_total = 0;
				while ($temp = mysql_fetch_row($result)) {
					$child_status_total = $child_status_total + $temp[0];
				}
				$parent->status = $child_status_total / count($parent->children);
				$parent->add_slashes();
				$parent->update();
			}
		}
	}
	else {
		return false;
	}
}

function get_task_status($task_id) {
	global $database;
	$task = new task;
	$task = $task->retrieve($task_id);
	if (count($task->children) > 0) {
		$result = mysql_query("SELECT status FROM $database->table_name WHERE parent = '$task_id' AND obsolete != '1'");
		$child_status_total = 0;
		while ($temp = mysql_fetch_row($result)) {
			$child_status_total = $child_status_total + $temp[0];
		}
		$task->status = $child_status_total / count($task->children);
		return $task->status;
	}
	else {
		return $task->status;
	}
}

function set_task_status($task_id) {
	global $database;
	$task = new task;
	$task = $task->retrieve($task_id);
	if (count($task->children) > 0) {
		$result = mysql_query("SELECT status FROM $database->table_name WHERE parent = '$task_id' AND obsolete != '1'");
		$child_status_total = 0;
		while ($temp = mysql_fetch_row($result)) {
			$child_status_total = $child_status_total + $temp[0];
		}
		$task->status = $child_status_total / count($task->children);
		$task->add_slashes();
		$task->update();
	}
	else {
		$task->add_slashes();
		$task->update();
	}
}

function get_notes_height($task) {
	if (strlen($task->notes) <= 200 && substr_count($task->notes, "\n") < 2) {
		$height = "30px";
	}
	elseif (strlen($task->notes) < 400 && substr_count($task->notes, "\n") < 5) {
		$height = "60px";
	}
	else {
		$height = "100px";
	}
	return $height;
}

function print_task_view($task) {
	$notes_HTML = get_HTML($task->notes);
	print("					<table width=\"100%\" cellpadding=\"0\" cellspacing=\"5\" border=\"0\">\n");
	if ($task->notes != "") {
		print("						<tr valign=\"top\">\n");
		print("							<td width=\"1%\" align=\"center\"><span class=\"label\">Notes:</span><br><nobr><img src=\"images/icon_notes_increase.gif\" height=\"16\" width=\"16\" onclick=\"increaseNotesHeight(document.getElementById('task_notes_".$task->id."'), 50);\" class=\"hand\" title=\"Make the Notes field bigger\"><img src=\"images/icon_notes_decrease.gif\" height=\"16\" width=\"16\" onclick=\"decreaseNotesHeight(document.getElementById('task_notes_".$task->id."'), 50);\" class=\"hand\" title=\"Make the Notes field smaller\"></nobr></td>\n");
		$height = get_notes_height($task);
		print("							<td><textarea id=\"task_notes_".$task->id."\" cols=\"40\" class=\"one_pixel_border\" style=\"height: ".$height."; width: 100%;\" wrap=\"virtual\" readonly>".$notes_HTML."</textarea></td>\n");
		print("						</tr>\n");
	}
	if (($task->URL_1 != "") ||	($task->URL_2 != "") || ($task->URL_3 != "")) {
		print("						<tr valign=\"top\">\n");
		print("							<td align=\"right\">URLs:</td>\n");
		print("							<td>\n");
		if ($task->URL_1 != "") {
			print("									<a href=\"".$task->URL_1."\" target=\"_blank\">".trim_add_elipsis($task->URL_1, 75)."</a>\n");
			print("									<br><img src=\"images/clear.gif\" width=\"1\" height=\"3\"><br>\n");
		}
		if ($task->URL_2 != "") {
			print("									<a href=\"".$task->URL_2."\" target=\"_blank\">".trim_add_elipsis($task->URL_2, 75)."</a>\n");
			print("									<br><img src=\"images/clear.gif\" width=\"1\" height=\"3\"><br>\n");
		}
		if ($task->URL_3 != "") {
			print("									<a href=\"".$task->URL_3."\" target=\"_blank\">".trim_add_elipsis($task->URL_3, 75)."</a>\n");
			print("									<br><img src=\"images/clear.gif\" width=\"1\" height=\"3\"><br>\n");
		}
		print("							</td>\n");
		print("						</tr>\n");
	}
	print("						<tr valign=\"top\">\n");
	print("							<td colspan=\"2\">\n");
	print("								<span class=\"label\">Date Entered:</span> ");
	print_friendly_timestamp($task->date_entered);
	print("<br>\n");
	print("								<span class=\"label\">Last Modified:</span> ");
	print_friendly_timestamp($task->date_modified);
	print("\n");
	print("							</td>\n");
	print("						</tr>\n");
	print("					</table>\n");
	print("\n");
}

function print_task_view_m($task, $screen = "focus") {
	global $_REQUEST;
	global $root;
	$title_HTML = get_HTML($task->title);
	$notes_HTML = get_HTML($task->notes);
	print('					<table width="100%" cellpadding="0" cellspacing="5" border="0">'."\n");
	print("						<tr>\n");
	$task->container == 1 ? $temp = "*" : $temp = "";
	if ($task->status != 100) {
		$title_HTML = "<b>".$title_HTML."</b>";
	}
	print("							<td colspan=\"2\">".$temp.$title_HTML);
	print("<br>[ <a href=\"mobile.php?screen=edit&id=".$task->id."\">Edit</a> | <a href=\"mobile.php?screen=edit&root=".$root."&parent=".$task->id."\">New Sub-Task</a> | <a href=\"mobile.php?screen=".$screen."&action=delete&id=".$task->id."\">Delete</a> ]");
	print("</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\">Notes:<br>".$notes_HTML."</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\"><nobr>".$task->status."%&nbsp;Complete</nobr></td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\">\n");
	$temp = array(array(1
	                   ,"Lowest"
	                   )
	             ,array(2
	                   ,"Low"
	                   )
	             ,array(3
	                   ,"Medium"
	                   )
	             ,array(4
	                   ,"High"
	                   )
	             ,array(5
	                   ,"Highest"
	                   )
	             );
	foreach ($temp as $priority) {
		if ($task->priority == $priority[0]) {
			print($priority[1]);
		}
	}
	print(" Priority</td>\n");
	print("						</tr>\n");
	if ($task->parent != 0) {
		print("						<tr>\n");
		print("							<td>Parent: ");
		print($task->parent);
		print("							</td>\n");
		print("						</tr>\n");
	}
	if ($task->container == 1) {
		print("						<tr>\n");
		print("							<td>");
		print("Sticky Task");
		print("							</td>\n");
		print("						</tr>\n");
	}
	if ($task->date_due != '0000-00-00') {
		print("						<tr valign=\"top\">\n");
		print("							<td>Date&nbsp;Due:<br>\n");
		print($task->date_due);
		print("							</td>\n");
		print("						</tr>\n");
	}
	if (($task->URL_1 != "") ||	($task->URL_2 != "") || ($task->URL_3 != "")) {
		print("						<tr>\n");
		print("							<td>URLs:<br>\n");
		if ($task->URL_1 != "") {
			print("									<a href=\"".$task->URL_1."\" target=\"_blank\">".trim_add_elipsis($task->URL_1, 50)."</a><br>\n");
		}
		if ($task->URL_2 != "") {
			print("									<a href=\"".$task->URL_2."\" target=\"_blank\">".trim_add_elipsis($task->URL_2, 50)."</a><br>\n");
		}
		if ($task->URL_3 != "") {
			print("									<a href=\"".$task->URL_3."\" target=\"_blank\">".trim_add_elipsis($task->URL_3, 50)."</a><br>\n");
		}
		print("							</td>\n");
		print("						</tr>\n");
	}
	if (count($task->children) > 0) {
		if (count($task->open_children) == 1) {
			$subtask_label = "Open Sub-Task";
		}
		else {
			$subtask_label = "Open Sub-Tasks";
		}
		print("						<tr>\n");
		print("							<td colspan=\"2\">\n");
		print("								".count($task->open_children)." ".$subtask_label." (".count($task->children)." Total)\n");
		print("							</td>\n");
		print("						</tr>\n");
	}
	print("					</table>\n");
}

function print_task_edit($task, $height = 250) {
	global $_REQUEST;
	global $root;
	if (!empty($root) && $root != 0) {
		$screen = "focus";
	}
	else {
		$screen = "home";
	}
	$title_HTML = get_HTML($task->title);
	$notes_HTML = get_HTML($task->notes);
	print('			<div class="header">'."\n");
	if (empty($task->id)) {
		print("New Task");
	}
	else {
		print("Edit Task");
	}
	print('			</div>'."\n");
	print('			<div id="edit_form_div" class="form" style="position: relative;>'."\n");
// hack to handle weird spacing with IE and mozilla
	global $HTTP_SERVER_VARS;
	if (strstr(strtolower($HTTP_SERVER_VARS["HTTP_USER_AGENT"]), "msie") != false) {
		print(" width: 100%;");
	}
	print('">'."\n");
	ob_start();
		print('					<table width="100%" cellpadding="0" cellspacing="1" border="0" class="form_toolbar">'."\n");
		print('						<tr>'."\n");
		print('							<td width="1%">&nbsp;</td>'."\n");
		print('							<td width="1%" class="hand"><table class="form_button" onclick="document.edit.submit();" title="Save" onmouseover="this.className=\'form_button_on\';" onmousedown="this.className=\'form_button_down\';" onmouseup="this.className=\'form_button_on\';" onmouseout="this.className=\'form_button\';"><tr><td style="padding-left: 3px;"><img src="images/icon_save.gif" border="0" height="16" width="16" alt="Save" /></td><td><u>S</u>ave&nbsp;</td></tr></table>'."\n");
		if (!empty($task->id) && $task->id != 0) {
			print('							<td width="1%" class="hand"><table class="form_button" onclick="duplicateTask();" title="Save as New Task"onmouseover="this.className=\'form_button_on\';" onmousedown="this.className=\'form_button_down\';" onmouseup="this.className=\'form_button_on\';" onmouseout="this.className=\'form_button\';"><tr><td><img src="images/clear.gif" border="0" height="16" width="1" alt=""/></td><td><nobr>Save as New Task&nbsp;</nobr></td></tr></table>'."\n");
			print('							<td width="1%" class="hand"><table class="form_button" onclick="location.href=\'index.php?screen=edit&parent='.$task->id.'&root='.$root.'\';" title="New Sub-Task" onmouseover="this.className=\'form_button_on\';" onmousedown="this.className=\'form_button_down\';" onmouseup="this.className=\'form_button_on\';" onmouseout="this.className=\'form_button\';"><tr><td style="padding-left: 3px;"><img src="images/icon_new_child.gif" border="0" height="16" width="16" alt="New Sub-Task" /></td><td><nobr>New Sub-Task&nbsp;</nobr></td></tr></table>'."\n");
			print('							<td width="1%" class="hand"><table class="form_button" onclick="if (document.edit.task_id.value != \'\' ) { if (confirm(\'Delete task '.addslashes($title_HTML).'?\')) { location.href=\'index.php?screen='.$screen.'&root='.$root.'&id='.$task->id.'&action=delete\'; } }" title="Delete" onmouseover="this.className=\'form_button_on\';" onmousedown="this.className=\'form_button_down\';" onmouseup="this.className=\'form_button_on\';" onmouseout="this.className=\'form_button\';"><tr><td style="padding-left: 3px;"><img src="images/icon_delete.gif" border="0" height="16" width="16" alt="Delete" /></td><td><nobr>Delete&nbsp;</nobr></td></tr></table>'."\n");
		}
		print('							<td width="1%" class="hand"><table class="form_button" onclick="annotate();" title="Insert current date/time in Notes field" onmouseover="this.className=\'form_button_on\';" onmousedown="this.className=\'form_button_down\';" onmouseup="this.className=\'form_button_on\';" onmouseout="this.className=\'form_button\';"><tr><td style="padding-left: 3px;"><img src="images/icon_annotate.gif" border="0" height="16" width="16" alt="Insert Date/Time" /></td><td><nobr>Insert Date/Time&nbsp;</nobr></td></tr></table>'."\n");
		print('							<td width="100%">&nbsp;</td>'."\n");
		print('						</tr>'."\n");
		print('					</table>'."\n");
	$toolbar = ob_get_contents();
	ob_end_clean();
	print($toolbar);
	print('					<table width="100%" cellpadding="0" cellspacing="0" border="0">'."\n");
	print('						<tr valign="top">'."\n");
	print('							<td style="padding-bottom: 0px; padding-left: 10px; padding-right: 5px; padding-top: 5px;">');
	print('After Save: ');
	if (isset($_REQUEST["post_save_nav"]) && $_REQUEST["post_save_nav"] == "continue") {
		print('<input type="radio" name="post_save_nav" value="view">');
		print(' <span class="hand" onclick="setSelectedRadioButton(document.edit.post_save_nav, \'view\');">View Tree</span>');
		print('&nbsp;&nbsp;');
		print('<input type="radio" name="post_save_nav" value="parent" onclick="if (verifyParentIsSet() == false) { setSelectedRadioButton(document.edit.post_save_nav, \'view\'); }">');
		print(' <span class="hand" onclick="if (verifyParentIsSet() == false) { setSelectedRadioButton(document.edit.post_save_nav, \'view\'); } else { setSelectedRadioButton(document.edit.post_save_nav, \'parent\'); }">View Parent Task</span>');
		print('&nbsp;&nbsp;');
		print('<input type="radio" name="post_save_nav" value="continue" checked>');
		print(' <span class="hand" onclick="setSelectedRadioButton(document.edit.post_save_nav, \'continue\');">Stay Here</span>');
	}
	else {
		print('<input type="radio" name="post_save_nav" value="view" checked>');
		print(' <span class="hand" onclick="setSelectedRadioButton(document.edit.post_save_nav, \'view\');">View Tree</span>');
		print('&nbsp;&nbsp;');
		print('<input type="radio" name="post_save_nav" value="parent" onclick="if (verifyParentIsSet() == false) { setSelectedRadioButton(document.edit.post_save_nav, \'view\'); }">');
		print(' <span class="hand" onclick="if (verifyParentIsSet() == false) { setSelectedRadioButton(document.edit.post_save_nav, \'view\'); } else { setSelectedRadioButton(document.edit.post_save_nav, \'parent\'); }">View Parent Task</span>');
		print('&nbsp;&nbsp;');
		print('<input type="radio" name="post_save_nav" value="continue">');
		print(' <span class="hand" onclick="setSelectedRadioButton(document.edit.post_save_nav, \'continue\');">Stay Here</span>');
	}
	print('&nbsp;&nbsp;');
	print('<input type="radio" name="post_save_nav" value="home">');
	print(' <span class="hand" onclick="setSelectedRadioButton(document.edit.post_save_nav, \'home\');">Return Home</span>');
	print("</td>\n");
	print("						</tr>\n");
	print("					</table>\n");
	print('					<table width="100%" cellpadding="0" cellspacing="10" border="0">'."\n");
	print("						<tr valign=\"top\">\n");
	print("							<td colspan=\"3\" style=\"background: #ff6;\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\" alt=\"\"></td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td width=\"1%\" align=\"right\"><div class=\"label\">Title:</div></td>\n");
	print("							<td colspan=\"2\"><input type=\"text\" name=\"task_title\" class=\"one_pixel_border\" style=\"width: 100%;\" value=\"".$title_HTML."\" onkeyup=\"update_breadcrumbs();\" onchange=\"setConfirmNav();\"></td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td width=\"1%\" align=\"right\">");
	print("<div class=\"label\">Notes:</div><nobr><img src=\"images/icon_notes_increase.gif\" height=\"16\" width=\"16\" onclick=\"increaseNotesHeight(document.edit.task_notes, 50);position_corner();\" class=\"hand\" title=\"Make the Notes field bigger\"><img src=\"images/icon_notes_decrease.gif\" height=\"16\" width=\"16\" onclick=\"decreaseNotesHeight(document.edit.task_notes, 50);position_corner();\" class=\"hand\" title=\"Make the Notes field smaller\"></nobr>");
	print("							<td><textarea name=\"task_notes\" class=\"one_pixel_border\" cols=\"40\" style=\"height: ".$height."px; width: 100%;\" wrap=\"virtual\" onchange=\"setConfirmNav();\">".$notes_HTML."</textarea></td>\n");
	print("							<td width=\"10%\">\n");
	if (count($task->children) == 0) {
		print("								<span class=\"label\">% Complete:</span><br>\n");
		$temp = array(array(0
						   ,"0%"
						   )
					 ,array(25
						   ,"25%"
						   )
					 ,array(50
						   ,"50%"
						   )
					 ,array(75
						   ,"75%"
						   )
					 ,array(100
						   ,"100%"
						   )
					 );
		print_dropdown("task_status", $temp, $task->status, 'width: 100%', 'onchange="setConfirmNav();"');
	}
	else {
		print("								".$task->status."% Complete\n");
		print('								<input type="hidden" name="task_status" value="'.$task->status.'">'."\n");
	}
	print("								<br><img src=\"images/clear.gif\" height=\"5\" width=\"100\"><br>\n");
	print("								<span class=\"label\">Priority:</span><br>\n");
	$temp = array(array(1
	                   ,"Lowest"
	                   )
	             ,array(2
	                   ,"Low"
	                   )
	             ,array(3
	                   ,"Medium"
	                   )
	             ,array(4
	                   ,"High"
	                   )
	             ,array(5
	                   ,"Highest"
	                   )
	             );
	print_dropdown("task_priority", $temp, $task->priority, 'width: 100%', 'onchange="setConfirmNav();"');
	print("								<br><img src=\"images/clear.gif\" height=\"5\" width=\"1\"><br>\n");
	print("								<span class=\"label\">Parent:</span><br>\n");
	if ($task->parent == 0) {
		$task->parent = "";
	}
//	print("								<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">\n");
//	print("									<tr>\n");
//	print("										<td>\n");
	print("											<input name=\"task_parent\" type=\"text\" value=\"".$task->parent."\" class=\"one_pixel_border\" style=\"width: 50;\" onchange=\"setConfirmNav();\">\n");
//	print("										</td>\n");
//	print("										<td width=\"1%\">\n");
//	print("											<nobr><img src=\"images/clear.gif\" height=\"1\" width=\"2\" alt=\"\">");
	print(" <img src=\"images/icon_lookup.gif\" height=\"16\" width=\"16\" align=\"absbottom\" alt=\"Choose a Parent\" title=\"Choose a parent\" class=\"hand\" onclick=\"showPicker('parent',document.edit.task_parent);\"><br>\n");
//	print("										</td>\n");
//	print("									</tr>\n");
//	print("								</table>");
	print("<img src=\"images/clear.gif\" height=\"5\" width=\"1\">");
	print("<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\">\n");
	print("									<tr>\n");
	print("										<td width=\"1%\">");
	print('<input type="checkbox" name="task_container" value="1"');
	if ($task->container == 1) {
		print(" checked");
	}
	print(" onchange=\"setConfirmNav();\">");
	print("</td>\n");
	print("										<td width=\"1%\"><nobr>&nbsp;");
	print("<img src=\"images/icon_container.gif\" class=\"hand\" onclick=\"toggleCheckbox(document.edit.task_container);\"></nobr>\n");
	print("</td>\n");
	print("										<td class=\"label hand\" onclick=\"toggleCheckbox(document.edit.task_container);\">&nbsp;Sticky&nbsp;Task</td>\n");
	print("									</tr>\n");
	print("								</table>\n");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td align=\"right\"><div class=\"label\">Date&nbsp;Due:</div></td>\n");
	print("							<td>\n");
	$temp = array(array("",""));
	for ($i = 1; $i < 13; $i++) {
		$temp[] = array(substr($i+100,1)
		               ,$i
		               );
	}
	print_dropdown("task_month", $temp, substr($task->date_due, 5, 2),"", 'onchange="setConfirmNav();"');
	$temp = array(array("",""));
	for ($i = 1; $i < 32; $i++) {
		$temp[] = array(substr($i+100,1)
		               ,$i
		               );
	}
	print_dropdown("task_day", $temp, substr($task->date_due, 8, 2),"", 'onchange="setConfirmNav();"');
	$temp = array(array("",""));
	global $custom;
	if (substr($task->date_due, 0, 4) > 0 && substr($task->date_due, 0, 4) < $custom->year_min) {
		$custom->year_min = substr($task->date_due, 0, 4);
	}
	for ($i = $custom->year_min; $i <= $custom->year_max; $i++) {
		$temp[] = array($i
		               ,$i
		               );
	}
	print_dropdown("task_year", $temp, substr($task->date_due, 0, 4),"", 'onchange="setConfirmNav();"');
	print('<input type="button" value="Choose Date" onclick="showPicker(\'date\',selectedDate(\'edit\',\'task\'));">'."\n");
	print('<input type="button" value="Clear" onclick="setSelectToValue(document.edit.task_month, \'\'); setSelectToValue(document.edit.task_day, \'\'); setSelectToValue(document.edit.task_year, \'\');">'."\n");
	print("							</td>\n");
	print("							<td></td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td></td>\n");
	print("							<td>\n");
	print('<input type="button" value="Today" onclick="setSelectToValue(document.edit.task_month, \''.date("m").'\'); setSelectToValue(document.edit.task_day, \''.date("d").'\'); setSelectToValue(document.edit.task_year, \''.date("Y").'\');">'."\n");
	$temp = mktime() + 86400;
	print('<input type="button" value="Tomorrow" onclick="setSelectToValue(document.edit.task_month, \''.date("m", $temp).'\'); setSelectToValue(document.edit.task_day, \''.date("d", $temp).'\'); setSelectToValue(document.edit.task_year, \''.date("Y", $temp).'\');">'."\n");
	$temp = mktime() + 604800;
	print('<input type="button" value="1 Week" onclick="setSelectToValue(document.edit.task_month, \''.date("m", $temp).'\'); setSelectToValue(document.edit.task_day, \''.date("d", $temp).'\'); setSelectToValue(document.edit.task_year, \''.date("Y", $temp).'\');">'."\n");
	$temp = mktime() + 2592000;
	print('<input type="button" value="30 Days" onclick="setSelectToValue(document.edit.task_month, \''.date("m", $temp).'\'); setSelectToValue(document.edit.task_day, \''.date("d", $temp).'\'); setSelectToValue(document.edit.task_year, \''.date("Y", $temp).'\');">'."\n");
	$temp = mktime() + 7776000;
	print('<input type="button" value="90 Days" onclick="setSelectToValue(document.edit.task_month, \''.date("m", $temp).'\'); setSelectToValue(document.edit.task_day, \''.date("d", $temp).'\'); setSelectToValue(document.edit.task_year, \''.date("Y", $temp).'\');">'."\n");
	$temp = mktime();
	print('<input type="button" value="1 Year" onclick="setSelectToValue(document.edit.task_month, \''.date("m", $temp).'\'); setSelectToValue(document.edit.task_day, \''.date("d", $temp).'\'); setSelectToValue(document.edit.task_year, \''.(date("Y", $temp) + 1).'\');">'."\n");
	print("							</td>\n");
	print("							<td></td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td align=\"right\"><div class=\"label\">URLs:</div></td>\n");
	print("							<td>\n");
	print("								<input type=\"text\" name=\"task_URL_1\" class=\"one_pixel_border\" style=\"width: 100%;\" value=\"".$task->URL_1."\" onchange=\"setConfirmNav();\">");
	print("<br><img src=\"images/clear.gif\" width=\"1\" height=\"3\"><br>");
	print("<input type=\"text\" name=\"task_URL_2\" class=\"one_pixel_border\" style=\"width: 100%;\" value=\"".$task->URL_2."\" onchange=\"setConfirmNav();\">");
	print("<br><img src=\"images/clear.gif\" width=\"1\" height=\"3\"><br>");
	print("<input type=\"text\" name=\"task_URL_3\" class=\"one_pixel_border\" style=\"width: 100%;\" value=\"".$task->URL_3."\" onchange=\"setConfirmNav();\">\n");
	print("							</td>\n");
	print("							<td></td>\n");
	print("						</tr>\n");
	if (!empty($task->id)) {
		print("						<tr valign=\"top\">\n");
		print("							<td colspan=\"3\">\n");
		print("								<span class=\"label\">Date Entered:</span> ");
		print_friendly_timestamp($task->date_entered);
		print("<br>\n");
		print("								<span class=\"label\">Last Modified:</span> ");
		print_friendly_timestamp($task->date_modified);
		print("\n");
		print("							</td>\n");
		print("						</tr>\n");
	}
	if (count($task->children) > 0) {
		if (count($task->open_children) == 1) {
			$subtask_label = "Open Sub-Task";
		}
		else {
			$subtask_label = "Open Sub-Tasks";
		}
		print("						<tr valign=\"top\">\n");
		print("							<td colspan=\"2\">\n");
		print("								<div id=\"task_children_summary_".$task->id."\" class=\"task_background_odd\" style=\"padding: 3px;\">".count($task->open_children)." ".$subtask_label." <span style=\"color: #666;\">(".count($task->children)." Total)</span></div>\n");
		print("							</td>\n");
		print("						</tr>\n");
	}
	print("					</table>\n");
	print($toolbar);
	print('				<img src="images/edit_form_corner.gif" id="edit_form_corner" style="position:absolute; z-index:100; visibility:hidden;">'."\n");
	print('			</div>'."\n");
}

function print_task_edit_m($task, $screen = "focus") {
	global $_REQUEST;
	global $root;
	$title_HTML = get_HTML($task->title);
	$notes_HTML = get_HTML($task->notes);
	print('<p><b>'."\n");
	if (empty($task->id)) {
		print("New Task");
	}
	else {
		print("Edit Task");
	}
	print('</b></p>'."\n");
	print('					<table width="100%" cellpadding="0" cellspacing="5" border="0">'."\n");
	print('						<tr>'."\n");
	print('							<td colspan="2">');
	print('								<input type="submit" value="Save">');
	print(' and: ');
	if (isset($_REQUEST["post_save_nav"])) {
		$value = $_REQUEST["post_save_nav"];
	}
	else {
		$value = "view";
	}
	$temp = array(array("view"
					   ,"View Tree"
					   )
				 ,array("parent"
					   ,"View Parent"
					   )
				 ,array("continue"
					   ,"Stay Here"
					   )
				 ,array("home"
					   ,"Return Home"
					   )
				 );
	print_dropdown("post_save_nav", $temp, $value, "");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\">[ <a href=\"mobile.php?screen=edit&root=".$root."&parent=".$task->id."\">New Sub-Task</a> | <a href=\"mobile.php?screen=focus&action=delete&id=".$task->id."\">Delete</a> ]</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\">Title:<br><input type=\"text\" name=\"task_title\" size=\"25\" value=\"".$title_HTML."\"></td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\">Notes:<br><textarea name=\"task_notes\" class=\"one_pixel_border\" cols=\"25\" rows=\"5\" wrap=\"virtual\">".$notes_HTML."</textarea></td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\"><nobr>");
	if (count($task->children) == 0) {
		$temp = array(array(0
						   ,"0%"
						   )
					 ,array(25
						   ,"25%"
						   )
					 ,array(50
						   ,"50%"
						   )
					 ,array(75
						   ,"75%"
						   )
					 ,array(100
						   ,"100%"
						   )
					 );
		print_dropdown("task_status", $temp, $task->status, "");
	}
	else {
		print($task->status);
	}
	print("%&nbsp;Complete</nobr></td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td width=\"1%\" align=\"right\">Priority:</td>\n");
	print("							<td>\n");
	$temp = array(array(1
	                   ,"Lowest"
	                   )
	             ,array(2
	                   ,"Low"
	                   )
	             ,array(3
	                   ,"Medium"
	                   )
	             ,array(4
	                   ,"High"
	                   )
	             ,array(5
	                   ,"Highest"
	                   )
	             );
	print_dropdown("task_priority", $temp, $task->priority, "");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td align=\"right\">Parent:</td>\n");
	print("							<td>\n");
	if ($task->parent == 0) {
		$display_parent = "";
	}
	else {
		$display_parent = $task->parent;
	}
	print("								<input name=\"task_parent\" type=\"text\" value=\"".$display_parent."\" size=\"5\">\n");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr>\n");
	print("							<td colspan=\"2\"><nobr>");
	print('<input type="checkbox" name="task_container" value="1"');
	if ($task->container == 1) {
		print(" checked");
	}
	print("> Sticky Task");
	print("</nobr>");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td align=\"right\">Date&nbsp;Due:</td>\n");
	print("							<td>\n");
	$temp = array(array("",""));
	for ($i = 1; $i < 13; $i++) {
		$temp[] = array(substr($i+100,1)
		               ,$i
		               );
	}
	print_dropdown("task_month", $temp, substr($task->date_due, 5, 2),"");
	$temp = array(array("",""));
	for ($i = 1; $i < 32; $i++) {
		$temp[] = array(substr($i+100,1)
		               ,$i
		               );
	}
	print_dropdown("task_day", $temp, substr($task->date_due, 8, 2),"");
	$temp = array(array("",""));
	global $custom;
	for ($i = $custom->year_min; $i <= $custom->year_max; $i++) {
		$temp[] = array($i
		               ,$i
		               );
	}
	print_dropdown("task_year", $temp, substr($task->date_due, 0, 4),"");
	print("							</td>\n");
	print("						</tr>\n");
	print("						<tr valign=\"top\">\n");
	print("							<td colspan=\"2\">URLs:<br>\n");
	print("								<input type=\"text\" name=\"task_URL_1\" size=\20\" value=\"".$task->URL_1."\"><br>\n");
	print("								<input type=\"text\" name=\"task_URL_2\" size=\20\" value=\"".$task->URL_2."\"><br>\n");
	print("								<input type=\"text\" name=\"task_URL_3\" size=\20\" value=\"".$task->URL_3."\">\n");
	print("							</td>\n");
	print("						</tr>\n");
	if (count($task->children) > 0) {
		if (count($task->open_children) == 1) {
			$subtask_label = "Open Sub-Task";
		}
		else {
			$subtask_label = "Open Sub-Tasks";
		}
		print("						<tr>\n");
		print("							<td colspan=\"2\">\n");
		print("								".count($task->open_children)." ".$subtask_label." (".count($task->children)." Total)\n");
		print("							</td>\n");
		print("						</tr>\n");
	}
	print('						<tr>'."\n");
	print('							<td colspan="2">');
	print('								<input type="submit" value="Save">');
	print("							</td>\n");
	print("						</tr>\n");
	print("					</table>\n");
}

function print_task_level($task, $color = 0, $show = 0, $root = 0, $screen = "", $show_completed_tasks = 0, $levels = 0) {
	$title_HTML = get_HTML($task->title);
	if ($color == 0) {
		$child_color = 1;
		$task_class = "task_background_odd";
		$task_child_class = "task_background_even";
		$hr_color = "#fff";
	}
	else {
		$child_color = 0;
		$task_class = "task_background_even";
		$task_child_class = "task_background_odd";
		$hr_color = "#ddd";
	}
	global $action;
	if ($task->id == $show && (isset($_REQUEST["action"]) && $_REQUEST["action"] == "save")) {
		$task_class = "task_background_focus";
	}
	$tree_display_task = new task;
	if ($show != 0) {
		$tree_display_task = $tree_display_task->retrieve($show);
	}
	if ($root != 0) {
		$screen = "focus";
	}
	else {
		$screen = "home";
	}
	if ($show_completed_tasks == 1) {
		$displayed_children = $task->children;
	}
	else {
		$displayed_children = $task->open_children;
	}
	print("<div id=\"task_div_".$task->id."\" class=\"".$task_class."\">\n");
	print("	<a name=\"".$task->id."\">\n");
/* not needed unless using the expand all functionality
	print("	<script language=\"JavaScript\">\n");
	print("	<!--\n");
	print("	var task_children_".$task->id." = Array(");
	for ($i = 0; $i < count($displayed_children); $i++) {
		print($displayed_children[$i]);
		if ($i + 1 < count($displayed_children)) {
			print(",");
		}
	}
	print(");\n");
	print("	//-->\n");
	print("	</script>\n");
*/
	print("	<table width=\"100%\" cellpadding=\"0\" cellspacing=\"5\" border=\"0\">\n");
	print("		<tr valign=\"top\">\n");
	if (($show_completed_tasks == 1 && count($task->children) > 0) || ($show_completed_tasks == 0 && count($task->open_children) > 0)) {
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			if ($levels < 1) {
				$levels = 1;
			}
			print("			<td width=\"1%\"><a href=\"javascript:uRailToggleTreeNode('".$task->id."',".$child_color.",".$root.",'".$screen."',".$show.",".$show_completed_tasks.");\"><img src=\"images/tree_open.gif\" border=\"0\" id=\"tree_icon_".$task->id."\" alt=\"Hide or show sub-tasks for this task\" title=\"Hide or show sub-tasks for this task\"></a></td>\n");
		}
		else {
			print("			<td width=\"1%\"><a href=\"javascript:uRailToggleTreeNode('".$task->id."',".$child_color.",".$root.",'".$screen."',".$show.",".$show_completed_tasks.");\"><img src=\"images/tree_closed.gif\" border=\"0\" id=\"tree_icon_".$task->id."\" alt=\"Hide or show sub-tasks for this task\" title=\"Hide or show sub-tasks for this task\"></a></td>\n");
		}
	}
	else {
		print("			<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"16\"></td>\n");
	}
	print("			<td>\n");
	print("				<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n");
	print("					<tr>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"3\"></td>\n");
	print("						<td width=\"1%\" valign=\"top\"><img src=\"images/icon_priority_".$task->priority.".gif\" height=\"16\" width=\"14\" alt=\"Priority: ".get_friendly_priority($task->priority)."\" title=\"Priority: ".get_friendly_priority($task->priority)."\"></td>\n");
	if ($task->container == 1) {
		print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></td>\n");
		print("						<td width=\"1%\" valign=\"top\"><img src=\"images/icon_container.gif\" height=\"16\" width=\"13\" title=\"Sticky Task\"></td>\n");
	}
	print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></td>\n");
	if ($task->obsolete == 1) {
		$obsolete = "style=\"color: black; text-decoration: line-through;\"";
	}
	else {
		$obsolete = "";
	}
	print("						<td width=\"79%\">");
	print("<a href=\"index.php?screen=focus&root=".$task->id."&id=".$task->id."\" ".$obsolete.">");
	if ($task->status == "100") {
		print($title_HTML);
	}
	else {
		print("<b>".$title_HTML."</b>");
	}
	print("</a>");
	if ($task->date_due != "0000-00-00" || ($task->status != 0 && $task->status != 100)) {
		print("<br>");
		if ($task->status != 0 && $task->status != 100) {
		print($task->status."% Complete");
		}
		if ($task->date_due != "0000-00-00" && $task->status != 100) {
			print(" - Due: ");
			print_relative_date_due($task->date_due);
		}
	}
	print("</td>\n");
	print("						<td width=\"10%\" align=\"right\" nowrap>ID: ".$task->id."</td>\n");
	if ($task->obsolete != 1) {
		print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	// edit
		print("						<td width=\"1%\"><a href=\"index.php?screen=edit&id=".$task->id."&root=".$root."\"><img src=\"images/icon_edit.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"edit_icon_".$task->id."\" alt=\"Edit\" title=\"Edit\"></a></td>\n");
		print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	// new child
		print("						<td width=\"1%\"><a href=\"index.php?screen=edit&parent=".$task->id."&root=".$root."\"><img src=\"images/icon_new_child.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"new_child_icon_".$task->id."\" alt=\"New Sub-Task\" title=\"New Sub-Task\"></a></td>\n");
		print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	// complete
		if ($task->status == 100) {
			print("						<td width=\"1%\"><img src=\"images/icon_complete_x.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Completed Task\" title=\"Completed Task\"></td>\n");
		}
		else {
			print("						<td width=\"1%\"><a href=\"javascript:markComplete(".$task->id.", '".$screen."', ".$root.");\"><img src=\"images/icon_complete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Mark Complete\" title=\"Mark Complete\"></a></td>\n");
		}
		print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	// delete
		print("						<td width=\"1%\"><a href=\"javascript:if (confirm('Delete task: ".addslashes($title_HTML)."?')) { location.href='index.php?screen=".$screen."&root=".$root."&id=".$task->id."&action=delete'; }\"><img src=\"images/icon_delete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"delete_icon_".$task->id."\" alt=\"Delete\" title=\"Delete\"></a></td>\n");
	}
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	if ($task->id == $show) {
		print("						<td width=\"1%\"><a href=\"javascript:toggleForm('".$task->id."');\"><img src=\"images/form_open.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"form_icon_".$task->id."\" alt=\"Show or hide more information for this task\" title=\"Show or hide more information for this task\"></a></td>\n");
	}
	else {
		print("						<td width=\"1%\"><a href=\"javascript:toggleForm('".$task->id."');\"><img src=\"images/form_closed.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"form_icon_".$task->id."\" alt=\"Show or hide more information for this task\" title=\"Show or hide more information for this task\"></a></td>\n");
	}
//	print("						<td width=\"1%\"><a href=\"javascript:toggleForms('".$task->id."', task_children_".$task->id.");");
//	print("\"><img src=\"images/forms_closed.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"forms_icon_".$task->id."\"></a></td>\n");
	print("					</tr>\n");
	print("				</table>\n");
	if ($task->id == $show) {
		$temp_display = "block";
	}
	else {
		$temp_display = "none";
	}
	print("				<div id=\"task_body_".$task->id."\" style=\"display: ".$temp_display."\">\n");
	print("					<div style=\"background: ".$hr_color."; margin-top: 5px;\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></div>\n");
	print_task_view($task);
	if (count($task->children) > 0) {
		if (count($task->open_children) == 1) {
			$subtask_label = "Open Sub-Task";
		}
		else {
			$subtask_label = "Open Sub-Tasks";
		}
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			$temp_display = "none";
		}
		else {
			$temp_display = "block";
		}
		print("				<div id=\"task_children_summary_".$task->id."\" class=\"".$task_child_class."\" style=\"display: ".$temp_display."; padding: 3px;\">".count($task->open_children)." ".$subtask_label." <span style=\"color: #666;\">(".count($task->children)." Total)</span></div>\n");
	}
	print("				</div>\n");
	if (count($task->children) > 0) {
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			$temp_display = "block";
		}
		else {
			$temp_display = "none";
		}
		print("				<div id=\"task_children_".$task->id."\" style=\"display: ".$temp_display."; color: #666;\">");
		if ($levels > 0) {
			for ($i = 0; $i < count($displayed_children); $i++) {
				$child = new task;
				$child->retrieve($displayed_children[$i]);
				if ($color == 0) {
					$new_color = 1;
				}
				else {
					$new_color = 0;
				}
				print_task_level($child, $new_color, $show, $root, $screen, $show_completed_tasks, $levels - 1);
			}
		}
		else {
			print("Loading...");
		}
		print("</div>\n");
	}
	print("			</td>\n");
	print("		</tr>\n");
	print("	</table>\n");
	print("</div>");
}

function print_task_tree($task, $color = 0, $show = 0, $root = 0, $screen = "", $show_completed_tasks = 0) {
	$title_HTML = get_HTML($task->title);
	if ($color == 0) {
		$task_class = "task_background_odd";
		$task_child_class = "task_background_even";
		$hr_color = "#fff";
	}
	else {
		$task_class = "task_background_even";
		$task_child_class = "task_background_odd";
		$hr_color = "#ddd";
	}
	global $action;
	if ($task->id == $show && (isset($_REQUEST["action"]) && $_REQUEST["action"] == "save")) {
		$task_class = "task_background_focus";
	}
	$tree_display_task = new task;
	if ($show != 0) {
		$tree_display_task = $tree_display_task->retrieve($show);
	}
	if ($root != 0) {
		$screen = "focus";
	}
	else {
		$screen = "home";
	}
	if ($show_completed_tasks == 1) {
		$displayed_children = $task->children;
	}
	else {
		$displayed_children = $task->open_children;
	}
	print("<div id=\"task_div_".$task->id."\" class=\"".$task_class."\">\n");
	print("	<a name=\"".$task->id."\">\n");
	print("	<script language=\"JavaScript\">\n");
	print("	<!--\n");
	print("	var task_children_".$task->id." = Array(");
	for ($i = 0; $i < count($displayed_children); $i++) {
		print($displayed_children[$i]);
		if ($i + 1 < count($displayed_children)) {
			print(",");
		}
	}
	print(");\n");
	print("	//-->\n");
	print("	</script>\n");
	print("	<table width=\"100%\" cellpadding=\"0\" cellspacing=\"5\" border=\"0\">\n");
	print("		<tr valign=\"top\">\n");
	if (($show_completed_tasks == 1 && count($task->children) > 0) || ($show_completed_tasks == 0 && count($task->open_children) > 0)) {
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			print("			<td width=\"1%\"><a href=\"javascript:toggleTreeNode('".$task->id."');\"><img src=\"images/tree_open.gif\" border=\"0\" id=\"tree_icon_".$task->id."\" alt=\"Hide or show sub-tasks for this task\" title=\"Hide or show sub-tasks for this task\"></a></td>\n");
		}
		else {
			print("			<td width=\"1%\"><a href=\"javascript:toggleTreeNode('".$task->id."');\"><img src=\"images/tree_closed.gif\" border=\"0\" id=\"tree_icon_".$task->id."\" alt=\"Hide or show sub-tasks for this task\" title=\"Hide or show sub-tasks for this task\"></a></td>\n");
		}
	}
	else {
		print("			<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"16\"></td>\n");
	}
	print("			<td>\n");
	print("				<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\">\n");
	print("					<tr>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"3\"></td>\n");
	print("						<td width=\"1%\" valign=\"top\"><img src=\"images/icon_priority_".$task->priority.".gif\" height=\"16\" width=\"14\" alt=\"Priority: ".get_friendly_priority($task->priority)."\" title=\"Priority: ".get_friendly_priority($task->priority)."\"></td>\n");
	if ($task->container == 1) {
		print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></td>\n");
		print("						<td width=\"1%\" valign=\"top\"><img src=\"images/icon_container.gif\" height=\"16\" width=\"13\" title=\"Sticky Task\"></td>\n");
	}
	print("						<td width=\"1%\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></td>\n");
	print("						<td width=\"79%\">");
	print("<a href=\"index.php?screen=focus&root=".$task->id."&id=".$task->id."\">");
	if ($task->status == "100") {
		print($title_HTML);
	}
	else {
		print("<b>".$title_HTML."</b>");
	}
	print("</a>");
	if ($task->date_due != "0000-00-00" || ($task->status != 0 && $task->status != 100)) {
		print("<br>");
		if ($task->status != 0 && $task->status != 100) {
		print($task->status."% Complete");
		}
		if ($task->date_due != "0000-00-00" && $task->status != 100) {
			print(" - Due: ");
			print_relative_date_due($task->date_due);
		}
	}
	print("</td>\n");
	print("						<td width=\"10%\" align=\"right\" nowrap>ID: ".$task->id."</td>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
// edit
	print("						<td width=\"1%\"><a href=\"index.php?screen=edit&id=".$task->id."&root=".$root."\"><img src=\"images/icon_edit.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"edit_icon_".$task->id."\" alt=\"Edit\" title=\"Edit\"></a></td>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
// new child
	print("						<td width=\"1%\"><a href=\"index.php?screen=edit&parent=".$task->id."&root=".$root."\"><img src=\"images/icon_new_child.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"new_child_icon_".$task->id."\" alt=\"New Sub-Task\" title=\"New Sub-Task\"></a></td>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
// complete
	if ($task->status == 100) {
		print("						<td width=\"1%\"><img src=\"images/icon_complete_x.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Completed Task\" title=\"Completed Task\"></td>\n");
	}
	else {
		print("						<td width=\"1%\"><a href=\"javascript:markComplete(".$task->id.", '".$screen."', ".$root.");\"><img src=\"images/icon_complete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Mark Complete\" title=\"Mark Complete\"></a></td>\n");
	}
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
// delete
	print("						<td width=\"1%\"><a href=\"javascript:if (confirm('Delete task: ".addslashes($title_HTML)."?')) { location.href='index.php?screen=".$screen."&root=".$root."&id=".$task->id."&action=delete'; }\"><img src=\"images/icon_delete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"delete_icon_".$task->id."\" alt=\"Delete\" title=\"Delete\"></a></td>\n");
	print("						<td width=\"1%\"><img src=\"images/clear.gif\"height=\"1\" width=\"5\"></td>\n");
	if ($task->id == $show) {
		print("						<td width=\"1%\"><a href=\"javascript:toggleForm('".$task->id."');\"><img src=\"images/form_open.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"form_icon_".$task->id."\" alt=\"Show or hide more information for this task\" title=\"Show or hide more information for this task\"></a></td>\n");
	}
	else {
		print("						<td width=\"1%\"><a href=\"javascript:toggleForm('".$task->id."');\"><img src=\"images/form_closed.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"form_icon_".$task->id."\" alt=\"Show or hide more information for this task\" title=\"Show or hide more information for this task\"></a></td>\n");
	}
//	print("						<td width=\"1%\"><a href=\"javascript:toggleForms('".$task->id."', task_children_".$task->id.");");
//	print("\"><img src=\"images/forms_closed.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"forms_icon_".$task->id."\"></a></td>\n");
	print("					</tr>\n");
	print("				</table>\n");
	if ($task->id == $show) {
		$temp_display = "block";
	}
	else {
		$temp_display = "none";
	}
	print("				<div id=\"task_body_".$task->id."\" style=\"display: ".$temp_display."\">\n");
	print("					<div style=\"background: ".$hr_color."; margin-top: 5px;\"><img src=\"images/clear.gif\" height=\"1\" width=\"1\"></div>\n");
	print_task_view($task);
	if (count($task->children) > 0) {
		if (count($task->open_children) == 1) {
			$subtask_label = "Open Sub-Task";
		}
		else {
			$subtask_label = "Open Sub-Tasks";
		}
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			$temp_display = "none";
		}
		else {
			$temp_display = "block";
		}
		print("				<div id=\"task_children_summary_".$task->id."\" class=\"".$task_child_class."\" style=\"display: ".$temp_display."; padding: 3px;\">".count($task->open_children)." ".$subtask_label." <span style=\"color: #666;\">(".count($task->children)." Total)</span></div>\n");
	}
	print("				</div>\n");
	if (count($task->children) > 0) {
		if ((count($tree_display_task->lineage) > 0 && in_array($task->id, $tree_display_task->lineage)) || $task->id == $root) {
			$temp_display = "block";
		}
		else {
			$temp_display = "none";
		}
		print("				<div id=\"task_children_".$task->id."\" style=\"display: ".$temp_display."\">");
		for ($i = 0; $i < count($displayed_children); $i++) {
			$child = new task;
			$child->retrieve($displayed_children[$i]);
			if ($color == 0) {
				$new_color = 1;
			}
			else {
				$new_color = 0;
			}
			print_task_tree($child, $new_color, $show, $root, $screen, $show_completed_tasks);
		}
		print("				</div>\n");
	}
	print("			</td>\n");
	print("		</tr>\n");
	print("	</table>\n");
	print("</div>");
}

function print_task_tree_m($task, $color = 0, $show = 0, $root = 0, $screen = "", $show_completed_tasks = 0, $indent = 0, $top = 1) {
	$title_HTML = get_HTML(trim_add_elipsis($task->title, 25));
	if ($root != 0) {
		$screen = "focus";
	}
	else {
		$screen = "home";
	}
	if ($show_completed_tasks == 1) {
		$displayed_children = $task->children;
	}
	else {
		$displayed_children = $task->open_children;
	}
	if ($top == 1) {
		print('<p>');
	}
	print("<nobr>");
	for ($i = 0; $i < $indent; $i++) {
		print("&nbsp;-&nbsp;");
	}
	if ($task->container == 1) {
		print("*");
	}
	print("<a href=\"mobile.php?screen=focus&root=".$task->id."&id=".$task->id."\">");
	if ($task->status == "100") {
		print($title_HTML);
	}
	else {
		print("<b>".$title_HTML."</b>");
	}
	print("</a>");
	print(" [<a href=\"mobile.php?screen=edit&root=".$task->id."&id=".$task->id."\">edit</a>]");
	print("</nobr><br>\n");
	if (count($displayed_children) > 0) {
		foreach ($displayed_children as $temp) {
			$child = new task;
			$child->retrieve($temp);
			print_task_tree_m($child, 0, $show, $root, $screen, $show_completed_tasks, $indent + 1, 0);
		}
	}
	if ($top == 1) {
		print("&nbsp;</p>");
	}
}

function print_task_list($list = array(), $title, $screen = "confirm", $sorted_by = "", $return_query = "", $banner = "Showing # item(s)", $show_edit = 1, $show_complete = 1, $show_delete = 1, $show_new_child = 1, $show_duplicate = 0) {
	global $database;
	if (count($list) > 0) {
		$list_string = implode(",", $list);
	}
	else {
		$list_string = "";
	}
	$icon_sort_up = '<img src="images/icon_sort_up.gif" alt="" height="6" width="11">';
	$icon_sort_down = '<img src="images/icon_sort_down.gif" alt="" height="6" width="11">';
	print("<div class=\"groupBorder\"");
// hack to handle weird spacing with IE and mozilla
	global $HTTP_SERVER_VARS;
	if (strstr(strtolower($HTTP_SERVER_VARS["HTTP_USER_AGENT"]), "msie") != false) {
		print(" style=\"width: 100%;\"");
	}
	print(">\n");
	print("<div class=\"groupHeader\">\n");
	print("		".$title."\n");
	print("</div>\n");
	print("<table width=\"100%\" cellpadding=\"2\" cellspacing=\"1\">\n");
		if ($banner != "" && count($list) > 0) {
			$banner = str_replace("#", count($list), $banner);
			print('	<tr valign="top">'."\n");
			print('		<td colspan="10">'.$banner.'</td>'."\n");
			print('	</tr>'."\n");
		}
	print('	<tr class="rowHeader">'."\n");
	print('		<td width="5%">ID</td>'."\n");
	print('		<td width="1%"><img src="images/clear.gif" height="1" width="13" border="0" alt=""></td>'."\n");
	switch ($sorted_by) {
		case "title":
			$sort_string = "title";
			break;
		case "title_rev":
			$sort_string = "title DESC";
			break;
		case "date_due":
			$sort_string = "date_due, title";
			break;
		case "date_due_rev":
			$sort_string = "date_due DESC, title";
			break;
		case "date_modified":
			$sort_string = "date_modified DESC";
			break;
		case "priority":
			$sort_string = "priority DESC, title";
			break;
		case "priority_rev":
			$sort_string = "priority, title";
			break;
		case "status":
			$sort_string = "status DESC, title";
			break;
		case "status_rev":
			$sort_string = "status, title";
			break;
		default:
			$sorted_by = "title";
			$sort_string = "title";
			break;
	}
	if ($sorted_by == "title") {
		print('		<td><a href="index.php?screen='.$screen.'&sort=title_rev&list='.$list_string.$return_query.'">Title</a> '.$icon_sort_up.'</td>'."\n");
	}
	elseif ($sorted_by == "title_rev") {
		print('		<td><a href="index.php?screen='.$screen.'&sort=title_rev&list='.$list_string.$return_query.'">Title</a> '.$icon_sort_down.'</td>'."\n");
	}
	else {
		print('		<td><a href="index.php?screen='.$screen.'&sort=title&list='.$list_string.$return_query.'">Title</a></td>'."\n");
	}

	if ($sorted_by == "date_due") {
		print('		<td width="10%"><nobr><a href="index.php?screen='.$screen.'&sort=date_due_rev&list='.$list_string.$return_query.'">Date Due</a> '.$icon_sort_up.'</nobr></td>'."\n");
	}
	elseif ($sorted_by == "date_due_rev") {
		print('		<td width="10%"><nobr><a href="index.php?screen='.$screen.'&sort=date_due&list='.$list_string.$return_query.'">Date Due</a> '.$icon_sort_down.'</nobr></td>'."\n");
	}
	else {
		print('		<td width="10%"><nobr><a href="index.php?screen='.$screen.'&sort=date_due&list='.$list_string.$return_query.'">Date Due</a></nobr></td>'."\n");
	}

	if ($sorted_by == "status") {
		print('		<td width="5%" align="center" width="1%"><nobr><a href="index.php?screen='.$screen.'&sort=status_rev&list='.$list_string.$return_query.'">Status</a> '.$icon_sort_down.'</nobr></td>'."\n");
	}
	elseif ($sorted_by == "status_rev") {
		print('		<td width="5%" align="center" width="1%"><nobr><a href="index.php?screen='.$screen.'&sort=status&list='.$list_string.$return_query.'">Status</a> '.$icon_sort_up.'</nobr></td>'."\n");
	}
	else {
		print('		<td width="5%" align="center" width="1%"><nobr>&nbsp;<a href="index.php?screen='.$screen.'&sort=status&list='.$list_string.$return_query.'">Status</a>&nbsp;</nobr></td>'."\n");
	}

	if ($sorted_by == "priority") {
		print('		<td width="5%" align="center" width="1%"><nobr><a href="index.php?screen='.$screen.'&sort=priority_rev&list='.$list_string.$return_query.'">Priority</a> '.$icon_sort_down.'</nobr></td>'."\n");
	}
	elseif ($sorted_by == "priority_rev") {
		print('		<td width="5%" align="center" width="1%"><nobr><a href="index.php?screen='.$screen.'&sort=priority&list='.$list_string.$return_query.'">Priority</a> '.$icon_sort_up.'</nobr></td>'."\n");
	}
	else {
		print('		<td width="5%" align="center" width="1%"><nobr>&nbsp;<a href="index.php?screen='.$screen.'&sort=priority&list='.$list_string.$return_query.'">Priority</a>&nbsp;</nobr></td>'."\n");
	}
	if ($show_edit == 1) {
		print('		<td width="1%"><img src="images/clear.gif" height="1" width="16" alt="" /></td>'."\n");
	}
/*
	if ($show_duplicate == 1) {
		print('		<td width="1%"><img src="images/clear.gif" height="1" width="16" alt="" /></td>'."\n");
	}
*/
	if ($show_complete == 1) {
		print('		<td width="1%"><img src="images/clear.gif" height="1" width="16" alt="" /></td>'."\n");
	}
	if ($show_delete == 1) {
		print('		<td width="1%"><img src="images/clear.gif" height="1" width="16" alt="" /></td>'."\n");
	}
	if ($show_new_child == 1) {
		print('		<td width="1%"><img src="images/clear.gif" height="1" width="16" alt="" /></td>'."\n");
	}
	print("	</tr>\n");
	if (count($list) == 0) {
		print('	<tr valign="top" class="rowOdd">'."\n");
		print('		<td colspan="10">No items to display.</td>'."\n");
		print('	</tr>'."\n");
	}
	else {
		$result = mysql_query("SELECT parent, status FROM $database->table_name "
		                     ."WHERE parent != '0' "
		                     ."AND obsolete != '1' "
		                     );
		$parents = array();
		$parents_open = array();
		while (list($parent,$status) = mysql_fetch_array($result)) {
			if ($status != 100) {
				$parents_open[] = $parent;
			}
			$parents[] = $parent;
		}
		$result = mysql_query("SELECT ID, title, notes, status, priority, date_due, container, obsolete FROM $database->table_name "
		                     ."WHERE ID IN (".$list_string.") "
		                     ."ORDER BY ".$sort_string
		                     );
		$i = 0;
		while (list($id,$title,$notes,$status,$priority,$date_due,$container,$obsolete) = mysql_fetch_array($result)) {
			$task = new task;
			$task->id = $id;
			$task->title = $title;
			$task->notes = $notes;
			$task->status = $status;
			$task->priority = $priority;
			$task->date_due = $date_due;
			$task->container = $container;
			$task->obsolete = $obsolete;
			$children = array_count_values($parents);
			if (array_key_exists($task->id, $children)) {
				$children = $children[$task->id];
			}
			else {
				$children = 0;
			}
			$open_children = array_count_values($parents_open);
			if (array_key_exists($task->id, $open_children)) {
				$open_children = $open_children[$task->id];
			}
			else {
				$open_children = 0;
			}
			$title_HTML = get_HTML($task->title);
			if ($i % 2 == 0 || $i == 0) {
				$row_color = "rowOdd";
			}
			else {
				$row_color = "rowEven";
			}
			print('	<tr valign="top" class="'.$row_color.'">'."\n");
			print("		<td><a href=\"index.php?screen=focus&root=".$task->id."&id=".$task->id."\">".$task->id."</a></td>\n");
			print("		<td>");
			if ($task->container == 1) {
				print("<img src=\"images/icon_container.gif\" height=\"16\" width=\"13\" border=\"0\" alt=\"Sticky Task\" title=\"Sticky Task\">");
			}
			else {
				print("&nbsp;");
			}
			print("</td>\n");
			if ($children > 0) {
				if ($open_children == 1) {
					$subtask_label = "Open Sub-Task";
				}
				else {
					$subtask_label = "Open Sub-Tasks";
				}
				$temp = "<br>".$open_children." ".$subtask_label."  <span style=\"color: #666;\">(".$children." Total)</span>\n";
			}
			else {
				$temp = "";
			}
			if ($task->obsolete == 1) {
				$obsolete = "style=\"color: black; text-decoration: line-through;\"";
			}
			else {
				$obsolete = "";
			}
			if ($task->status == 100) {
				print("		<td><a href=\"index.php?screen=focus&root=".$task->id."&id=".$task->id."\" title=\"".trim_add_elipsis(get_HTML($task->notes),100)."\" ".$obsolete.">".$title_HTML."</a>".$temp."</td>\n");
			}
			else {
				print("		<td><a href=\"index.php?screen=focus&root=".$task->id."&id=".$task->id."\" title=\"".trim_add_elipsis(get_HTML($task->notes),100)."\" ".$obsolete."><b>".$title_HTML."</b></a>".$temp."</td>\n");
			}
			if ($task->obsolete == 1) {
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
				print("		<td>&nbsp;</td>\n");
			}
			else {
				if ($task->date_due != "0000-00-00") {
					print("		<td>");
					print_relative_date_due($task->date_due, 0);
					print("</td>\n");
				}
				else {
					print("		<td>&nbsp;</td>\n");
				}
				if ($task->status == 100) {
					print("		<td align=\"center\">(done)</td>\n");
				}
				else {
					print("		<td align=\"center\">".$task->status."%</td>\n");
				}
				print("		<td align=\"center\"><img src=\"images/icon_priority_".$task->priority.".gif\" height=\"16\" width=\"14\" alt=\"Priority: ".get_friendly_priority($task->priority)."\" title=\"Priority: ".get_friendly_priority($task->priority)."\"></td>\n");
				if ($show_edit == 1) {
					print("		<td align=\"center\"><a href=\"index.php?screen=edit&id=".$task->id."\"><img src=\"images/icon_edit.gif\" height=\"16\" width=\"16\" border=\"0\" alt=\"Edit\" title=\"Edit\"></a></td>\n");
				}
/*
				if ($show_duplicate == 1) {
					print("		<td align=\"center\"><a href=\"index.php?screen=edit&action=duplicate&id=".$task->id."\"><img src=\"images/icon_duplicate.gif\" height=\"16\" width=\"16\" border=\"0\" alt=\"Duplicate\" title=\"Duplicate\"></a></td>\n");
				}
*/
				if ($show_new_child == 1) {
					print("		<td align=\"center\"><a href=\"index.php?screen=edit&parent=".$task->id."\"><img src=\"images/icon_new_child.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"new_child_icon_".$task->id."\" alt=\"New Sub-Task\" title=\"New Sub-Task\"></a></td>\n");
				}
				if ($show_complete == 1) {
					if ($task->status == 100) {
						print("		<td align=\"center\"><img src=\"images/icon_complete_x.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Completed Task\" title=\"Completed Task\"></td>\n");
					}
					else {
						print("		<td align=\"center\"><a href=\"javascript:markComplete(".$task->id.", '".$screen."');\"><img src=\"images/icon_complete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"complete_icon_".$task->id."\" alt=\"Mark Complete\" title=\"Mark Complete\"></a></td>\n");
					}
				}
				if ($show_delete == 1) {
					print("		<td align=\"center\"><a href=\"javascript:if (confirm('Delete task ".addslashes($title_HTML)."?')) { location.href='index.php?screen=".$screen."&id=".$task->id."&action=delete'; }\"><img src=\"images/icon_delete.gif\" height=\"16\" width=\"16\" border=\"0\" id=\"delete_icon_".$task->id."\" alt=\"Delete\" title=\"Delete\"></a></td>\n");
				}
			}
			print("	</tr>\n");
			$i++;
		}
	}
	print("</table>\n");
	print("</div>\n");
}

function print_task_list_m($list, $title, $screen = "confirm", $banner = "(#)", $show_edit = 1, $show_complete = 1, $show_delete = 1, $show_new_child = 1, $show_duplicate = 0) {
	print("<table width=\"100%\" cellpadding=\"2\" cellspacing=\"1\">\n");
	if ($banner != "" && count($list) > 0) {
		$banner = str_replace("#", count($list), $banner);
	}
	print('	<tr valign="top">'."\n");
	print('		<td colspan="6"><b>'.$title.'</b> '.$banner.'</td>'."\n");
	print('	</tr>'."\n");
	if (count($list) == 0) {
		print('	<tr valign="top" class="rowOdd">'."\n");
		print('		<td colspan="10">No items to display.</td>'."\n");
		print('	</tr>'."\n");
	}
	else {
		$row_color = 1;
		for ($i = 0; $i < count($list); $i++) {
			set_time_limit(99999);
			$task = new task;
			$task = $task->retrieve($list[$i]);
			$title_HTML = get_HTML(trim_add_elipsis($task->title, 25));
			print('	<tr valign="top">'."\n");
			if (count($task->children) > 0) {
				$temp = " (".count($task->open_children)."/".count($task->children).")\n";
			}
			else {
				$temp = "";
			}
			$tools = " [ <a href=\"mobile.php?screen=edit&id=".$task->id."\">Edit</a> | <a href=\"mobile.php?screen=".$screen."&action=delete&id=".$task->id."\">Delete</a> ]";

			if ($task->status == 100) {
				print("		<td><a href=\"mobile.php?screen=focus&root=".$task->id."&id=".$task->id."\">".$title_HTML."</a>".$temp);
				print("<br>".$tools);
			}
			else {
				print("		<td><a href=\"mobile.php?screen=focus&root=".$task->id."&id=".$task->id."\"><b>".$title_HTML."</b></a>".$temp);
				print("<br>".$tools);
				if ($task->date_due != "0000-00-00") {
					print(" ".$task->status."% - ");
					print_relative_date_due($task->date_due);
				}
				else {
					print(" ".$task->status."%");
				}
			}
			print("</td>\n");
			print("	</tr>\n");
		}
	}
	print("</table>\n");
}

function trim_add_elipsis($string, $limit = 100) {
	if (strlen($string) > $limit) {
		$string = substr($string, 0, $limit)."...";
	}
	return $string;
}

function get_breadcrumbs($id) {
	$task = new task;
	$task = $task->retrieve($id);
	$breadcrumbs = "<a href=\"javascript:confirmNav('location.href=\'index.php?screen=home\'');\">Home</a>";
	for ($i = (count($task->lineage) - 1); $i >= 0; $i--) {
		$temp = new task;
		$temp = $temp->retrieve($task->lineage[$i]);
		$temp_title = trim_add_elipsis($temp->title, 25);
		$temp_title = get_HTML($temp_title);
		$breadcrumbs = $breadcrumbs." &gt; <a href=\"javascript:confirmNav('location.href=\'index.php?screen=focus&root=".$temp->id."\'');\">".$temp_title."</a>";
	}
	$temp_title = trim_add_elipsis($task->title, 25);
	$temp_title = get_HTML($temp_title);
	$breadcrumbs = $breadcrumbs.' &gt; <span id="current_breadcrumb">'.$temp_title.'</span>';
	return $breadcrumbs;
}

function get_breadcrumbs_m($id) {
	$task = new task;
	$task = $task->retrieve($id);
	$breadcrumbs = "<a href=\"index.php?screen=home\">Home</a>";
	for ($i = (count($task->lineage) - 1); $i >= 0; $i--) {
		$temp = new task;
		$temp = $temp->retrieve($task->lineage[$i]);
		$temp_title = trim_add_elipsis($temp->title, 25);
		$temp_title = get_HTML($temp_title);
		$breadcrumbs = $breadcrumbs." &gt; <a href=\"index.php?screen=focus&root=".$temp->id."\">".$temp_title."</a>";
	}
	$temp_title = trim_add_elipsis($task->title, 25);
	$temp_title = get_HTML($temp_title);
	$breadcrumbs = $breadcrumbs.' &gt; <span id="current_breadcrumb">'.$temp_title.'</span>';
	return $breadcrumbs;
}

function get_breadcrumbs_for_new_task($id) {
	$task = new task;
	$task = $task->retrieve($id);
	$breadcrumbs = "<a href=\"javascript:confirmNav('location.href=\'index.php?screen=home\'');\">Home</a>";
	for ($i = (count($task->lineage) - 1); $i >= 0; $i--) {
		$temp = new task;
		$temp = $temp->retrieve($task->lineage[$i]);
		$temp_title = trim_add_elipsis($temp->title, 25);
		$temp_title = get_HTML($temp_title);
		$breadcrumbs = $breadcrumbs." &gt; <a href=\"javascript:confirmNav('location.href=\'index.php?screen=focus&root=".$temp->id."\'');\"><nobr>".$temp_title."</nobr></a>";
	}
	$temp_title = trim_add_elipsis($task->title, 25);
	$temp_title = get_HTML($temp_title);
	$breadcrumbs = $breadcrumbs." &gt; <a href=\"javascript:confirmNav('location.href=\'index.php?screen=focus&root=".$task->id."\'');\"><nobr>".$temp_title."</nobr></a>";
	return $breadcrumbs;
}

function get_breadcrumbs_for_new_task_m($id) {
	$task = new task;
	$task = $task->retrieve($id);
	$breadcrumbs = "<a href=\"index.php?screen=home\">Home</a>";
	for ($i = (count($task->lineage) - 1); $i >= 0; $i--) {
		$temp = new task;
		$temp = $temp->retrieve($task->lineage[$i]);
		$temp_title = trim_add_elipsis($temp->title, 25);
		$temp_title = get_HTML($temp_title);
		$breadcrumbs = $breadcrumbs." &gt; <a href=\"index.php?screen=focus&root=".$temp->id."\"><nobr>".$temp_title."</nobr></a>";
	}
	$temp_title = trim_add_elipsis($task->title, 25);
	$temp_title = get_HTML($temp_title);
	$breadcrumbs = $breadcrumbs." &gt; <a href=\"index.php?screen=focus&root=".$task->id."\"><nobr>".$temp_title."</nobr></a>";
	return $breadcrumbs;
}

function print_dropdown($select_name, $options, $key, $style = "width: 100%;", $extra = "") {
	print("<select name=\"".$select_name."\" class=\"one_pixel_border\" style=\"".$style."\" ".$extra.">\n");
	for ($i = 0; $i < count($options); $i++) {
		if ($key == $options[$i][0]) {
			print("	<option value=\"".$options[$i][0]."\" selected>".$options[$i][1]."</option>\n");
		}
		else {
			print("	<option value=\"".$options[$i][0]."\">".$options[$i][1]."</option>\n");
		}
	}
	print("</select>\n");
}

function print_relative_date_due($date, $bold = 1) {
	if (!empty($date) && $date != "0000-00-00") {
		if ($date == date("Y-m-d")) {
			$friendly = "Today";
		}
		elseif ($date == date("Y-m-d", mktime() + 86400)) {
			$friendly = "Tomorrow";
		}
		elseif ($date == date("Y-m-d", mktime() + 172800)) {
			$friendly = "2 Days";
		}
		elseif ($date == date("Y-m-d", mktime() + 259200)) {
			$friendly = "3 Days";
		}
		elseif ($date == date("Y-m-d", mktime() + 345600)) {
			$friendly = "4 Days";
		}
		elseif ($date == date("Y-m-d", mktime() + 432000)) {
			$friendly = "5 Days";
		}
		elseif ($date == date("Y-m-d", mktime() + 518400)) {
			$friendly = "6 Days";
		}
		elseif ($date == date("Y-m-d", mktime() + 604800)) {
			$friendly = "1 Week";
		}
		elseif ($date == date("Y-m-d", mktime() - 86400)) {
			$friendly = "Yesterday";
		}
		elseif ($date == date("Y-m-d", mktime() - 172800)) {
			$friendly = "2 Days Ago";
		}
		elseif ($date == date("Y-m-d", mktime() - 259200)) {
			$friendly = "3 Days Ago";
		}
		elseif ($date == date("Y-m-d", mktime() - 345600)) {
			$friendly = "<b>4 Days Ago";
		}
		elseif ($date == date("Y-m-d", mktime() - 432000)) {
			$friendly = "5 Days Ago";
		}
		elseif ($date == date("Y-m-d", mktime() - 518400)) {
			$friendly = "6 Days Ago";
		}
		elseif ($date == date("Y-m-d", mktime() - 604800)) {
			$friendly = "1 Week Ago";
		}
		elseif ($date < date("Y-m-d")) {
			$friendly = $date;
		}
		else {
			$friendly = $date;
		}
		if ($bold == 1 && $date <= date("Y-m-d")) {
			$friendly = "<b>".$date."</b>";
		}
	}
	else {
		$friendly = "";
	}
	print($friendly);
}

function redirect_to_mobile() {
	global $HTTP_SERVER_VARS;
	$small_browsers = array("Elaine/3.0"
						   ,"Palm"
						   ,"EudoraWeb"
						   ,"Blazer"
						   ,"AvantGo"
						   ,"Windows CE"
						   ,"Cellphone"
						   ,"Small"
						   ,"MMEF20"
						   ,"Danger"
						   ,"hiptop"
						   ,"Proxinet"
						   ,"Newt"
						   );
	foreach ($small_browsers as $browser) {
		if (strstr($HTTP_SERVER_VARS["HTTP_USER_AGENT"], $browser) != false) {
			$URL = 'mobile.php';
			header("Location: $URL");
		}
	}
}

function get_friendly_priority($priority) {
	switch ($priority) {
		case "1":
			$temp = "Lowest";
			break;
		case "2":
			$temp = "Low";
			break;
		case "3":
			$temp = "Medium";
			break;
		case "4":
			$temp = "High";
			break;
		case "5":
			$temp = "Highest";
			break;
	}
	return $temp;
}

function print_parent_picker_tree($tasks, $level = 0, $color = 0, $parent, $target = "edit") {
	if ($level == 0) {
		$pre = "<b>";
		$post = "</b>";
	}
	else {
		$pre = "";
		$post = "";
	}
	$indent = "";	
	for ($i = 0; $i < $level; $i++) {
		$indent = $indent."&nbsp;&nbsp;&nbsp;&nbsp;";
	}
	foreach ($tasks as $task) {
		if ($task[2] == $parent) {
			if ($color == 0 || ($color % 2 == 0)) {
				$class = "rowEven";
			}
			else {
				$class = "rowOdd";
			}
			print("<div class='$class' style='padding: 3px;'><nobr>".$indent
			     ."<a href=\"javascript:pickParent('".$task[0]."','".$target."');\">".$pre.get_HTML(trim_add_elipsis($task[1],50)).$post."</a>"
			     ." (ID: <a href=\"javascript:pickParent('".$task[0]."','".$target."');\">".$task[0]."</a>)"
			     ."</nobr></div>\n");
			$color += 1;
			$color = print_parent_picker_tree($tasks, $level + 1, $color, $task[0], $target);
		}
	}
	return $color;
}

function microtime_diff($a, $b) {
   list($a_dec, $a_sec) = explode(" ", $a);
   list($b_dec, $b_sec) = explode(" ", $b);
   return $b_sec - $a_sec + $b_dec - $a_dec;
}

function print_safari_spacer() {
	global $HTTP_SERVER_VARS;
	if (strstr(strtolower($HTTP_SERVER_VARS["HTTP_USER_AGENT"]), "safari") != false) {
		print('<!-- this image is a "fix" for a bug in safari: http://www.alexking.org/dev/safari_bugs/safari_2.html -->'."\n");
		print('								<img src="images/clear.gif" height="1" class="search_label" alt="" />'."\n");
	}
}

?>